/*
 * RemoveCellRenderer
// by PhilFlash - http://philflash.inway.fr
 *
 * Dont't forget :
 * - to create a new symbol in Flash MX2004
 *   Insert > New Symbol
 *   with properties :
 *    Name : RemoveCellRenderer
 *    Behavior : MovieClip : Checked
 *   For Linkage:
 *    Identifier: RemoveCellRenderer
 *    AS 2.0 Class : RemoveCellRenderer
 *    Export for Actionscript : Checked
 *    Export for in first frame : Checked
 *
 * - to have a movie clip "trash" in your library
 *   With Linkage:
 *    Identifier: trash
 *    Export for Actionscript : Checked
 *    Export for in first frame : Checked
 *
 * - to have an Alert component in your library
 *
 */
 
import mx.core.UIComponent;
import mx.controls.Button;
import mx.controls.Alert;

class RemoveCellRenderer extends UIComponent
{
	private var close:Button;

 	var owner; // The row that contains this cell	
	var listOwner : MovieClip; // the reference we receive to the list
	var getCellIndex : Function; // the function we receive from the list
	var	getDataLabel : Function; // the function we receive from the list

	
	function RemoveCellRenderer()
	{
	}
	
	function init(Void):Void
	{
		super.init();

	}
	
	function createChildren(Void):Void
	{
		close = mx.controls.Button(createObject("Button", "close", 1));
		close.setSize(25, 25);
		
		close.icon = "trash";
		close.addEventListener("click", this);			
	}

	function size(Void):Void
	{
		
		close._x = (__width-25)/2;
		close._y = (__height-25)/2;
	}
	
	function setValue(value:String, item:Object, sel:Boolean):Void
	{
	
		close._visible = (item != undefined);
	}
	
	function getPreferredHeight(Void):Number
	{
		return 25;
	}

 	//function getPreferredWidth :: only really necessary for menu
 	
	function click(eventObj:Object):Void 
	{
		var target = eventObj.target;
		
		listOwner.selectedIndex = getCellIndex().itemIndex
		listOwner.dispatchEvent({ type:"cellEdit"});
		
		var name:String = listOwner.selectedItem.ProductName;
		var message:String = "Remove '"+name+"'. Are you sure ?";
		
		var confirm:Alert = Alert.show(message, "Remove by Icon", Alert.OK | Alert.CANCEL, this, this.confirmDeleteHandler, null, Alert.OK);
		confirm.owner = this;
		setLocationRelativeTo(confirm, listOwner);
	}
	
	// -----  -----	
	public function confirmDeleteHandler(eventObj:Object):Void {
		var detail = eventObj.detail;
		var target = eventObj.target;
		if (detail == Alert.OK || detail == Alert.YES) {
			var index = target.owner.listOwner.selectedIndex;
			target.owner.listOwner.removeItemAt(index);
			// For a mysterious bug for the first item (thanks to foxy)
			if (index == 0) {
				target.owner.listOwner.selectedIndex = 0;
			}
		}
	
	}
	// -----  -----

	function setLocationRelativeTo(mc:MovieClip, owner:Object) {
		var x0:Number = 0;
		var y0:Number = 0;
		if (owner != undefined && owner instanceof MovieClip) {
			x0 = owner._x+(owner._width/2);
			y0 = owner._y+(owner._height/2);	
			var x:Number = x0 - mc._width/2;
			var y:Number = y0 - mc._height/2;
			if (x < 0) {
				x = 0;
			}
			if (y < 0) {
				y = 0;
			}
			if (x + mc._width > Stage.width) {
				x = Stage.width - mc._width;
			}
			if (y + mc._height > Stage.height) {
				y = Stage.height - mc.height;
			}

			mc.move(x,y);		
		} else {
			mc.move((Stage.width-mc._width)/2, (Stage.height-mc._height)/2);	
		}
	}
}
